rpmbc.c File Reference
RPMPGP.
`#include "system.h"`
`#include <rpmbc.h>`
`#include "debug.h"`
Include dependency graph for rpmbc.c:

Go to the source code of this file.

## Macros

#define | _RPMBC_INTERNAL
#define | _RPMPGP_INTERNAL

## Functions

static unsigned char | nibble (char c)
| Convert hex to binary nibble. More...
static int | rpmbcSetRSA (DIGEST_CTX ctx, pgpDig dig, pgpDigParams sigp)
static int | rpmbcVerifyRSA (pgpDig dig)
static int | rpmbcSetDSA (DIGEST_CTX ctx, pgpDig dig, pgpDigParams sigp)
static int | rpmbcVerifyDSA (pgpDig dig)
static int | rpmbcSetECDSA (DIGEST_CTX ctx, pgpDig dig, pgpDigParams sigp)
static int | rpmbcVerifyECDSA (pgpDig dig)
static const char * | pgpMpiHex (const rpmuint8_t *p)
static int | pgpMpiSet (const char *pre, unsigned int lbits, void *dest, const rpmuint8_t *p, const rpmuint8_t *pend)
static int | rpmbcMpiItem (const char *pre, pgpDig dig, int itemno, const rpmuint8_t *p, const rpmuint8_t *pend)
static void | rpmbcClean (void *impl)
static void * | rpmbcFree (void *impl)
static void * | rpmbcInit (void)

## Variables

int | _pgp_debug
int | _pgp_print
struct pgpImplVecs_s | rpmbcImplVecs

## Macro Definition Documentation

#define _RPMBC_INTERNAL

Definition at line 6 of file rpmbc.c.

#define _RPMPGP_INTERNAL

Definition at line 7 of file rpmbc.c.

## Function Documentation

static unsigned char nibble | ( | char | c | ) |

static

Convert hex to binary nibble.

Parameters

  c | hex character

Returns
  binary nibble

Definition at line 28 of file rpmbc.c.

Referenced by rpmbcSetRSA().

static const char* pgpMpiHex | ( | const rpmuint8_t * | p | ) |

static

Definition at line 169 of file rpmbc.c.

References pgpHexCvt(), and pgpMpiLen().

Referenced by pgpMpiSet(), and rpmbcMpiItem().

static int pgpMpiSet | ( | const char * | pre,
|  | unsigned int | lbits,
|  | void * | dest,
|  | const rpmuint8_t * | p,
|  | const rpmuint8_t * | pend
| ) |  |

static

Returns
  0 on success

Definition at line 182 of file rpmbc.c.

References _free(), _pgp_debug, _pgp_print, pgpMpiBits(), pgpMpiHex(), and xmalloc().

Referenced by rpmbcMpiItem().

static void rpmbcClean | ( | void * | impl | ) |

static

Definition at line 279 of file rpmbc.c.

static void* rpmbcFree | ( | void * | impl | ) |

static

Definition at line 296 of file rpmbc.c.

References _free().

static void* rpmbcInit | ( | void |  | ) |

static

Definition at line 320 of file rpmbc.c.

References xcalloc().

static int rpmbcMpiItem | ( | const char * | pre,
|  | pgpDig | dig,
|  | int | itemno,
|  | const rpmuint8_t * | p,
|  | const rpmuint8_t * | pend
| ) |  |

static

Definition at line 220 of file rpmbc.c.

References _pgp_debug, _pgp_print, pgpMpiHex(), and pgpMpiSet().

static int rpmbcSetDSA | ( | DIGEST_CTX | ctx,
|  | pgpDig | dig,
|  | pgpDigParams | sigp
| ) |  |

static

Definition at line 108 of file rpmbc.c.

References rpmDigestAlgo(), and rpmDigestFinal().

static int rpmbcSetECDSA | ( | DIGEST_CTX | ctx,
|  | pgpDig | dig,
|  | pgpDigParams | sigp
| ) |  |

static

Definition at line 143 of file rpmbc.c.

References rpmDigestAlgo(), and rpmDigestFinal().

static int rpmbcSetRSA | ( | DIGEST_CTX | ctx,
|  | pgpDig | dig,
|  | pgpDigParams | sigp
| ) |  |

static

Definition at line 41 of file rpmbc.c.

References _free(), nibble(), rpmDigestAlgo(), rpmDigestASN1(), rpmDigestFinal(), stpcpy(), and xmalloc().

static int rpmbcVerifyDSA | ( | pgpDig | dig | ) |

static

Definition at line 129 of file rpmbc.c.

static int rpmbcVerifyECDSA | ( | pgpDig | dig | ) |

static

Definition at line 158 of file rpmbc.c.

static int rpmbcVerifyRSA | ( | pgpDig | dig | ) |

static

Definition at line 90 of file rpmbc.c.

## Variable Documentation

int _pgp_debug

Definition at line 26 of file rpmpgp.c.

int _pgp_print

Definition at line 29 of file rpmpgp.c.

Referenced by pgpMpiSet(), pgpPrtComment(), pgpPrtHex(), pgpPrtInt(), pgpPrtKey(), pgpPrtNL(), pgpPrtPkts(), pgpPrtPubkeyParams(), pgpPrtSeckeyParams(), pgpPrtSig(), pgpPrtSigParams(), pgpPrtStr(), pgpPrtSubType(), pgpPrtUserID(), pgpPrtVal(), and rpmbcMpiItem().

struct pgpImplVecs_s rpmbcImplVecs

Initial value:
= {
rpmbcSetRSA, rpmbcVerifyRSA,
rpmbcSetDSA, rpmbcVerifyDSA,
rpmbcSetECDSA, rpmbcVerifyECDSA,
rpmbcMpiItem, rpmbcClean,
rpmbcFree, rpmbcInit
}

Definition at line 327 of file rpmbc.c.

Referenced by rpmioAllArgCallback().